<?php

/* SSL Management */
$useSSL = true;

include dirname(__FILE__).'../../../config/config.inc.php';
include dirname(__FILE__).'../../../init.php';

$action_login = Tools::getValue('action_login');
$msg = '';

if ($action_login == 'login') {
    Hook::exec('actionBeforeAuthentication');

    $email = trim(Tools::getValue('email_ajax'));
    $passwd = trim(Tools::getValue('passwd_ajax'));
    $_POST['passwd_ajax'] = null;

    if (empty($email)) {
        $msg = array('error' => Tools::displayError('An email address required.'));
    } elseif (!Validate::isEmail($email)) {
        $msg = array('error' => Tools::displayError('Invalid email address.'));
    } elseif (empty($passwd)) {
        $msg = array('error' => Tools::displayError('Password is required.'));
    } elseif (!Validate::isPasswd($passwd)) {
        $msg = array('error' => Tools::displayError('Invalid password.'));
    } else {
        $customer = new Customer();
        $authentication = $customer->getByEmail(trim($email), trim($passwd));

        if (!$authentication or !$customer->id) {
            $msg = array('error' => Tools::displayError('Authentication failed.'));
        } elseif (isset($authentication->active) && !$authentication->active) {
            $msg = array('error' => Tools::displayError('Your account isn\'t available at this time, please contact us'));
        } else {
            $context = Context::getContext();

            $context->cookie->id_compare = isset($context->cookie->id_compare) ? $context->cookie->id_compare: CompareProduct::getIdCompareByIdCustomer($customer->id);
            $context->cookie->id_customer = (int)($customer->id);
            $context->cookie->customer_lastname = $customer->lastname;
            $context->cookie->customer_firstname = $customer->firstname;
            $context->cookie->logged = 1;
            $customer->logged = 1;
            $context->cookie->is_guest = $customer->isGuest();
            $context->cookie->passwd = $customer->passwd;
            $context->cookie->email = $customer->email;

            // Add customer to the context
            $context->customer = $customer;

            if (Configuration::get('PS_CART_FOLLOWING') && (empty($context->cookie->id_cart) || Cart::getNbProducts($context->cookie->id_cart) == 0) && $id_cart = (int)Cart::lastNoneOrderedCart($context->customer->id)) {
                $context->cart = new Cart($id_cart);
            } else {
                $id_carrier = (int)$context->cart->id_carrier;
                $context->cart->id_carrier = 0;
                $context->cart->setDeliveryOption(null);
                $context->cart->id_address_delivery = (int)Address::getFirstCustomerAddressId((int)($customer->id));
                $context->cart->id_address_invoice = (int)Address::getFirstCustomerAddressId((int)($customer->id));
            }
            $context->cart->id_customer = (int)$customer->id;
            $context->cart->secure_key = $customer->secure_key;

            $context->cart->save();
            $context->cookie->id_cart = (int)$context->cart->id;
            $context->cookie->write();
            $context->cart->autosetProductAddress();

            Hook::exec('actionAuthentication', array('customer' => $context->customer));

            // Login information have changed, so we check if the cart rules still apply
            CartRule::autoRemoveFromCart($context);
            CartRule::autoAddToCart($context);
            
            $msg = array('confirmation' => 1);
        }
    }
} elseif ($action_login == 'create_account') {
    $email = trim(Tools::getValue('email_create'));
    
    if (empty($email)) {
        $msg = array('error' => Tools::displayError('An email address required.'));
    } elseif (!Validate::isEmail($email)) {
        $msg = array('error' => Tools::displayError('Error: invalid e-mail address'));
    } elseif (Customer::customerExists($email)) {
        $_POST['email'] = Tools::getValue('email_create');
        unset($_POST['email_create']);
        $msg = array('error' => Tools::displayError('An account using this email address has already been registered.'));
    } else {
        $msg = array('confirmation' => 1);
    }
}

die(json_encode($msg));
